{ KOL MCK } // Do not remove this line!
{$DEFINE KOL_MCK}
unit Unit1;

interface

{$IFDEF KOL_MCK}
uses Windows, Messages, ShellAPI, KOL {$IFNDEF KOL_MCK}, mirror, Classes, Controls, mckControls, mckObjs, Graphics,
  mckCtrls {$ENDIF (place your units here->)};
{$ELSE}
{$I uses.inc}
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs;
{$ENDIF}

const
  BLACK_INDEX      = 0;
  RED_INDEX        = 13;
  GREEN_INDEX      = 14;
  BLUE_INDEX       = 16;
  X_WIDTH          = 300;
  X_HEIGHT         = 200;

  GLOBE    = 1;
  CYLINDER = 2;
  CONE     = 3;

  WM_USER_INVALID = WM_USER + 100;

type
  {$IFDEF KOL_MCK}
  {$I MCKfakeClasses.inc}
  {$IFDEF KOLCLASSES} TForm1 = class; PForm1 = TForm1; {$ELSE OBJECTS} PForm1 = ^TForm1; {$ENDIF CLASSES/OBJECTS}
  {$IFDEF KOLCLASSES}{$I TForm1.inc}{$ELSE} TForm1 = object(TObj) {$ENDIF}
    Form: PControl;
  {$ELSE not_KOL_MCK}
  TForm1 = class(TForm)
  {$ENDIF KOL_MCK}
    KOLProject1: TKOLProject;
    KOLForm1: TKOLForm;
    PaintBox1: TKOLPaintBox;
    Timer1: TKOLTimer;
    procedure KOLForm1FormCreate(Sender: PObj);
    procedure KOLForm1Destroy(Sender: PObj);
    procedure KOLForm1Close(Sender: PObj; var Accept: Boolean);
    function PaintBox1Message(var Msg: tagMSG; var Rslt: Integer): Boolean;
    procedure Timer1Timer(Sender: PObj);
    procedure PaintBox1Resize(Sender: PObj);
  private
    function GetHeight: Integer;
    function GetWidth: Integer;
    { Private declarations }
  public
    { Public declarations }
    gdiDC: HDC;
    ghRC: THandle;
    radius, latitude, longitude, latinc, longinc: Double;

    function bSetupPixelFormat: Boolean;
    function initializeGL( W, H: Integer ): Boolean;
    procedure createObjects;
    procedure drawScene;
    procedure polarView(_radius, twist, _latitude, _longitude: Double);
    property Width: Integer read GetWidth;
    property Height: Integer read GetHeight;
  end;

var
  Form1 {$IFDEF KOL_MCK} : PForm1 {$ELSE} : TForm1 {$ENDIF} ;

{$IFDEF KOL_MCK}
procedure NewForm1( var Result: PForm1; AParent: PControl );
{$ENDIF}

implementation

uses KOLOgl12;

{$IFNDEF KOL_MCK} {$R *.DFM} {$ENDIF}

{$IFDEF KOL_MCK}
{$I Unit1_1.inc}
{$ENDIF}

procedure TForm1.KOLForm1FormCreate(Sender: PObj);
var R: TRect;
begin
  if not InitOpenGL then
  begin
    ShowMessage( 'Can not initialize OpenGL' );
    PostQuitMessage( 0 );
    Exit;
  end;
  gdiDC := GetDC( PaintBox1.GetWindowHandle );
  if not bSetupPixelFormat then
  begin
    PostQuitMessage( 0 );
    Exit;
  end;
  ghRC := wglCreateContext(gdiDC);
  wglMakeCurrent(gdiDC, ghRC);
  GetClientRect(PaintBox1.Handle, R);
  initializeGL( R.right, R.bottom);
end;

procedure TForm1.KOLForm1Destroy(Sender: PObj);
begin
  if ghRC <> 0 then
  begin
    wglDeleteContext(ghRC);
    ghRC := 0;
  end;

  if gdiDC <> 0 then
  begin
    ReleaseDC( PaintBox1.Handle, gdiDC );
    gdiDC := 0;
  end;

  CloseOpenGL;
end;

procedure TForm1.KOLForm1Close(Sender: PObj; var Accept: Boolean);
begin
  if ghRC <> 0 then
  begin
    wglDeleteContext(ghRC);
    ghRC := 0;
  end;

  if gdiDC <> 0 then
  begin
    ReleaseDC( PaintBox1.Handle, gdiDC );
    gdiDC := 0;
  end;
end;

function TForm1.bSetupPixelFormat: Boolean;
var pfd: TPixelFormatDescriptor;
    PixelFormat: Integer;
begin
  Result := FALSE;
  FillChar( pfd, Sizeof( pfd ), 0 );
  pfd.nSize := sizeof( pfd );
  pfd.nVersion := 1;
  pfd.dwFlags := PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER;
  pfd.dwLayerMask := PFD_MAIN_PLANE;
  pfd.iPixelType := PFD_TYPE_COLORINDEX;
  pfd.cColorBits := 8;
  pfd.cDepthBits := 16;
  pfd.cAccumBits := 0;
  pfd.cStencilBits := 0;

  PixelFormat := ChoosePixelFormat( gdiDC, @ pfd );
  if PixelFormat = 0 then
  begin
    ShowMessage( 'ChoosePixelFormat failed' );
    Exit;
  end;

  if not SetPixelFormat( gdiDC, PixelFormat, @ pfd ) then
  begin
    ShowMessage( 'SetPixelFormat failed' );
    Exit;
  end;

  Result := TRUE;

end;

function TForm1.initializeGL(W, H: Integer): Boolean;
var maxObjectSize, aspect: TGLFloat;
    near_plane, far_plane: TGLDouble;
begin
  Result := FALSE; if not Result then;

    glClearIndex( BLACK_INDEX );
    glClearDepth( 1.0 );

    glEnable(GL_DEPTH_TEST);

    glMatrixMode( GL_PROJECTION );
    aspect := Width / Height;
    gluPerspective( 45.0, aspect, 3.0, 7.0 );
    glMatrixMode( GL_MODELVIEW );

    near_plane := 3.0;
    far_plane := 7.0;  if far_plane = 0 then;
    maxObjectSize := 3.0;
    radius := near_plane + maxObjectSize/2.0;

    latitude := 0.0;
    longitude := 0.0;
    latinc := 6.0;
    longinc := 2.5;

    createObjects();

  Result := TRUE;

end;

function TForm1.GetHeight: Integer;
begin
  Result := PaintBox1.Height;
end;

function TForm1.GetWidth: Integer;
begin
  Result := PaintBox1.Width;
end;

procedure TForm1.createObjects;
var quadObj: PGLUquadricObj;
begin

    glNewList(GLOBE, GL_COMPILE);
        quadObj := gluNewQuadric ();
        gluQuadricDrawStyle (quadObj, GLU_LINE);
        gluSphere (quadObj, 1.5, 16, 16);
    glEndList();

    glNewList(CONE, GL_COMPILE);
        quadObj := gluNewQuadric ();
        gluQuadricDrawStyle (quadObj, GLU_FILL);
        gluQuadricNormals (quadObj, GLU_SMOOTH);
        gluCylinder(quadObj, 0.3, 0.0, 0.6, 15, 10);
    glEndList();

    glNewList(CYLINDER, GL_COMPILE);
        glPushMatrix ();
        glRotatef(90.0, 1.0, 0.0, 0.0);
        glTranslatef (0.0, 0.0, -1.0);
        quadObj := gluNewQuadric ();
        gluQuadricDrawStyle (quadObj, GLU_FILL);
        gluQuadricNormals (quadObj, GLU_SMOOTH);
        gluCylinder (quadObj, 0.3, 0.3, 0.6, 12, 2);
        glPopMatrix ();
    glEndList();

end;

function TForm1.PaintBox1Message(var Msg: tagMSG;
  var Rslt: Integer): Boolean;
var paint: TPaintStruct;
begin
  Result := FALSE;
  if Msg.message = WM_PAINT then
  begin
    BeginPaint( PaintBox1.Handle, paint );
    drawScene;
    EndPaint( PaintBox1.Handle, paint );
    Result := TRUE;
  end
    else
  if Msg.message = WM_USER_INVALID then
  begin
    PaintBox1.Invalidate;
  end;
end;

procedure TForm1.drawScene;
begin
    glClear( GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT );

    glPushMatrix();

        //latitude := latitude + latinc;
        //longitude := longitude + longinc;

        polarView( radius, 0, latitude, longitude );

        glIndexi(RED_INDEX);
        glCallList(CONE);

        glIndexi(BLUE_INDEX);
        glCallList(GLOBE);

    glIndexi(GREEN_INDEX);
        glPushMatrix();
            glTranslatef(0.8, -0.65, 0.0);
            glRotatef(30.0, 1.0, 0.5, 1.0);
            glCallList(CYLINDER);
        glPopMatrix();

    glPopMatrix();

    SwapBuffers( gdiDC );
end;

procedure TForm1.polarView(_radius, twist, _latitude, _longitude: Double);
begin
    glTranslated(0.0, 0.0, -_radius);
    glRotated(-twist, 0.0, 0.0, 1.0);
    glRotated(_latitude, 1.0, 0.0, 0.0);
    glRotated(_longitude, 0.0, 0.0, 1.0);
end;

procedure TForm1.Timer1Timer(Sender: PObj);
begin
  latitude := latitude + latinc;
  longitude := longitude + longinc;
  PaintBox1.Postmsg( WM_USER_INVALID, 0, 0 );
end;

procedure TForm1.PaintBox1Resize(Sender: PObj);
var aspect: TGLFloat;
begin
    glViewport( 0, 0, Width, Height );

    aspect := Width / Height;

    glMatrixMode( GL_PROJECTION );
    glLoadIdentity();
    gluPerspective( 45.0, aspect, 3.0, 7.0 );
    glMatrixMode( GL_MODELVIEW );
end;

end.


